/* preferences-dialog.c generated by valac 0.46.6, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Copyright (C) 2009-2017 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>,
 *         Eduard Gotwig <g@ox.io>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef enum  {
	SCAN_TYPE_SINGLE,
	SCAN_TYPE_ADF_FRONT,
	SCAN_TYPE_ADF_BACK,
	SCAN_TYPE_ADF_BOTH,
	SCAN_TYPE_BATCH
} ScanType;

#define TYPE_SCAN_TYPE (scan_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_DEVICE (scan_device_get_type ())
#define SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_DEVICE, ScanDevice))
#define SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_DEVICE, ScanDeviceClass))
#define IS_SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_DEVICE))
#define IS_SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_DEVICE))
#define SCAN_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_DEVICE, ScanDeviceClass))

typedef struct _ScanDevice ScanDevice;
typedef struct _ScanDeviceClass ScanDeviceClass;
typedef struct _ScanDevicePrivate ScanDevicePrivate;

#define TYPE_PAGE_ICON (page_icon_get_type ())
#define PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_ICON, PageIcon))
#define PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_ICON, PageIconClass))
#define IS_PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_ICON))
#define IS_PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_ICON))
#define PAGE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_ICON, PageIconClass))

typedef struct _PageIcon PageIcon;
typedef struct _PageIconClass PageIconClass;
typedef struct _PageIconPrivate PageIconPrivate;
enum  {
	PAGE_ICON_0_PROPERTY,
	PAGE_ICON_NUM_PROPERTIES
};
static GParamSpec* page_icon_properties[PAGE_ICON_NUM_PROPERTIES];

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	gboolean setting_devices;
	gboolean user_selected_device;
	GtkComboBox* device_combo;
	GtkComboBox* text_dpi_combo;
	GtkComboBox* photo_dpi_combo;
	GtkComboBox* paper_size_combo;
	GtkScale* brightness_scale;
	GtkScale* contrast_scale;
	GtkListStore* device_model;
	GtkRadioButton* page_delay_3s_button;
	GtkRadioButton* page_delay_5s_button;
	GtkRadioButton* page_delay_7s_button;
	GtkRadioButton* page_delay_10s_button;
	GtkRadioButton* page_delay_15s_button;
	GtkListStore* text_dpi_model;
	GtkListStore* photo_dpi_model;
	GtkRadioButton* front_side_button;
	GtkRadioButton* back_side_button;
	GtkRadioButton* both_side_button;
	GtkListStore* paper_size_model;
	GtkAdjustment* brightness_adjustment;
	GtkAdjustment* contrast_adjustment;
};

struct _Block7Data {
	int _ref_count_;
	PreferencesDialog* self;
	GSettings* settings;
};

struct _ScanDevice {
	GObject parent_instance;
	ScanDevicePrivate * priv;
	gchar* name;
	gchar* label;
};

struct _ScanDeviceClass {
	GObjectClass parent_class;
};

struct _PageIcon {
	GtkDrawingArea parent_instance;
	PageIconPrivate * priv;
};

struct _PageIconClass {
	GtkDrawingAreaClass parent_class;
};

struct _PageIconPrivate {
	gchar* text;
	gdouble r;
	gdouble g;
	gdouble b;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;
static gint PageIcon_private_offset;
static gpointer page_icon_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
PreferencesDialog* preferences_dialog_new (GSettings* settings);
PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GSettings* settings);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
#define DEFAULT_TEXT_DPI 150
static void preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                       GtkComboBox* combo,
                                       gint default_dpi,
                                       gint current_dpi);
static void __lambda4_ (Block7Data* _data7_);
gint preferences_dialog_get_text_dpi (PreferencesDialog* self);
static void ___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
#define DEFAULT_PHOTO_DPI 300
static void __lambda5_ (Block7Data* _data7_);
gint preferences_dialog_get_photo_dpi (PreferencesDialog* self);
static void ___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
GType scan_type_get_type (void) G_GNUC_CONST;
static void preferences_dialog_set_page_side (PreferencesDialog* self,
                                       ScanType page_side);
static void __lambda6_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda7_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda8_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda9_ (Block7Data* _data7_);
gint preferences_dialog_get_brightness (PreferencesDialog* self);
static void ___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                               gpointer self);
static void __lambda10_ (Block7Data* _data7_);
gint preferences_dialog_get_contrast (PreferencesDialog* self);
static void ___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
void preferences_dialog_set_paper_size (PreferencesDialog* self,
                                        gint width,
                                        gint height);
static void __lambda11_ (Block7Data* _data7_);
gboolean preferences_dialog_get_paper_size (PreferencesDialog* self,
                                            gint* width,
                                            gint* height);
static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
void preferences_dialog_set_page_delay (PreferencesDialog* self,
                                        gint page_delay);
static void __lambda12_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda13_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda14_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda16_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
GType scan_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScanDevice, g_object_unref)
void preferences_dialog_set_scan_devices (PreferencesDialog* self,
                                          GList* devices);
static gboolean preferences_dialog_find_scan_device (PreferencesDialog* self,
                                              const gchar* device,
                                              GtkTreeIter* iter);
gchar* preferences_dialog_get_selected_device (PreferencesDialog* self);
gchar* preferences_dialog_get_selected_device_label (PreferencesDialog* self);
void preferences_dialog_set_selected_device (PreferencesDialog* self,
                                             const gchar* device);
ScanType preferences_dialog_get_page_side (PreferencesDialog* self);
void preferences_dialog_set_brightness (PreferencesDialog* self,
                                        gint brightness);
void preferences_dialog_set_contrast (PreferencesDialog* self,
                                      gint contrast);
gint preferences_dialog_get_page_delay (PreferencesDialog* self);
static void preferences_dialog_device_combo_changed_cb (PreferencesDialog* self,
                                                 GtkWidget* widget);
static void _preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void preferences_dialog_finalize (GObject * obj);
GType page_icon_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageIcon, g_object_unref)
#define PAGE_ICON_MINIMUM_WIDTH 20
PageIcon* page_icon_new (const gchar* text,
                         gdouble r,
                         gdouble g,
                         gdouble b);
PageIcon* page_icon_construct (GType object_type,
                               const gchar* text,
                               gdouble r,
                               gdouble g,
                               gdouble b);
static void page_icon_real_get_preferred_width (GtkWidget* base,
                                         gint* minimum_width,
                                         gint* natural_width);
static void page_icon_real_get_preferred_height (GtkWidget* base,
                                          gint* minimum_height,
                                          gint* natural_height);
static void page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                                    gint width,
                                                    gint* minimum_height,
                                                    gint* natural_height);
static void page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                                    gint height,
                                                    gint* minimum_width,
                                                    gint* natural_width);
static gboolean page_icon_real_draw (GtkWidget* base,
                              cairo_t* c);
static void page_icon_finalize (GObject * obj);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		PreferencesDialog* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda4_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "text-dpi", preferences_dialog_get_text_dpi (self));
}

static void
___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
	__lambda4_ (self);
}

static void
__lambda5_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "photo-dpi", preferences_dialog_get_photo_dpi (self));
}

static void
___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
	__lambda5_ (self);
}

static void
__lambda6_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_FRONT);
	}
}

static void
___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda6_ (self, _sender);
}

static void
__lambda7_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_BACK);
	}
}

static void
___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda7_ (self, _sender);
}

static void
__lambda8_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_BOTH);
	}
}

static void
___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda8_ (self, _sender);
}

static void
__lambda9_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "brightness", preferences_dialog_get_brightness (self));
}

static void
___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                          gpointer self)
{
	__lambda9_ (self);
}

static void
__lambda10_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	self = _data7_->self;
	g_settings_set_int (_data7_->settings, "contrast", preferences_dialog_get_contrast (self));
}

static void
___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
	__lambda10_ (self);
}

static void
__lambda11_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	self = _data7_->self;
	preferences_dialog_get_paper_size (self, &_tmp0_, &_tmp1_);
	w = _tmp0_;
	h = _tmp1_;
	g_settings_set_int (_data7_->settings, "paper-width", w);
	g_settings_set_int (_data7_->settings, "paper-height", h);
}

static void
___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda11_ (self);
}

static void
__lambda12_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 3000);
	}
}

static void
___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda12_ (self, _sender);
}

static void
__lambda13_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 5000);
	}
}

static void
___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda13_ (self, _sender);
}

static void
__lambda14_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 7000);
	}
}

static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda14_ (self, _sender);
}

static void
__lambda15_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 10000);
	}
}

static void
___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda15_ (self, _sender);
}

static void
__lambda16_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data7_->self;
	g_return_if_fail (button != NULL);
	_tmp0_ = gtk_toggle_button_get_active (button);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_settings_set_int (_data7_->settings, "page-delay", 15000);
	}
}

static void
___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda16_ (self, _sender);
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GSettings* settings)
{
	PreferencesDialog * self = NULL;
	Block7Data* _data7_;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkListStore* _tmp10_;
	GtkTreeIter _tmp11_ = {0};
	GtkListStore* _tmp12_;
	GtkTreeIter _tmp13_;
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_ = {0};
	GtkListStore* _tmp16_;
	GtkTreeIter _tmp17_;
	GtkListStore* _tmp18_;
	GtkTreeIter _tmp19_ = {0};
	GtkListStore* _tmp20_;
	GtkTreeIter _tmp21_;
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_ = {0};
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_;
	GtkListStore* _tmp26_;
	GtkTreeIter _tmp27_ = {0};
	GtkListStore* _tmp28_;
	GtkTreeIter _tmp29_;
	GtkListStore* _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkCellRendererText* _tmp36_;
	GtkComboBox* _tmp37_;
	GtkCellRendererText* _tmp38_;
	gint dpi = 0;
	GtkComboBox* _tmp39_;
	GtkComboBox* _tmp40_;
	GtkComboBox* _tmp41_;
	GtkComboBox* _tmp42_;
	GtkRadioButton* _tmp43_;
	GtkRadioButton* _tmp44_;
	GtkRadioButton* _tmp45_;
	GtkCellRendererText* _tmp46_;
	GtkComboBox* _tmp47_;
	GtkCellRendererText* _tmp48_;
	GtkComboBox* _tmp49_;
	GtkCellRendererText* _tmp50_;
	gdouble lower = 0.0;
	GtkAdjustment* _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gchar* darker_label = NULL;
	gchar* _tmp54_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gchar* lighter_label = NULL;
	gchar* _tmp58_;
	GtkScale* _tmp59_;
	GtkScale* _tmp60_;
	GtkScale* _tmp61_;
	GtkAdjustment* _tmp62_;
	GtkAdjustment* _tmp63_;
	GtkAdjustment* _tmp64_;
	gdouble _tmp65_;
	gdouble _tmp66_;
	gchar* less_label = NULL;
	gchar* _tmp67_;
	GtkAdjustment* _tmp68_;
	gdouble _tmp69_;
	gdouble _tmp70_;
	gchar* more_label = NULL;
	gchar* _tmp71_;
	GtkScale* _tmp72_;
	GtkScale* _tmp73_;
	GtkScale* _tmp74_;
	GtkAdjustment* _tmp75_;
	GtkAdjustment* _tmp76_;
	gint paper_width = 0;
	gint paper_height = 0;
	GtkComboBox* _tmp77_;
	GtkRadioButton* _tmp78_;
	GtkRadioButton* _tmp79_;
	GtkRadioButton* _tmp80_;
	GtkRadioButton* _tmp81_;
	GtkRadioButton* _tmp82_;
	g_return_val_if_fail (settings != NULL, NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (_data7_->settings);
	_data7_->settings = _tmp0_;
	self = (PreferencesDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
	_data7_->self = g_object_ref (self);
	_tmp1_ = _g_object_ref0 (_data7_->settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp1_;
	_tmp2_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp2_, &_tmp3_);
	iter = _tmp3_;
	_tmp4_ = self->priv->paper_size_model;
	_tmp5_ = iter;
	gtk_list_store_set (_tmp4_, &_tmp5_, 0, 0, 1, 0, 2, _ ("Automatic"), -1, -1);
	_tmp6_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp6_, &_tmp7_);
	iter = _tmp7_;
	_tmp8_ = self->priv->paper_size_model;
	_tmp9_ = iter;
	gtk_list_store_set (_tmp8_, &_tmp9_, 0, 1050, 1, 1480, 2, "A6", -1, -1);
	_tmp10_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp10_, &_tmp11_);
	iter = _tmp11_;
	_tmp12_ = self->priv->paper_size_model;
	_tmp13_ = iter;
	gtk_list_store_set (_tmp12_, &_tmp13_, 0, 1480, 1, 2100, 2, "A5", -1, -1);
	_tmp14_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp14_, &_tmp15_);
	iter = _tmp15_;
	_tmp16_ = self->priv->paper_size_model;
	_tmp17_ = iter;
	gtk_list_store_set (_tmp16_, &_tmp17_, 0, 2100, 1, 2970, 2, "A4", -1, -1);
	_tmp18_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp18_, &_tmp19_);
	iter = _tmp19_;
	_tmp20_ = self->priv->paper_size_model;
	_tmp21_ = iter;
	gtk_list_store_set (_tmp20_, &_tmp21_, 0, 2970, 1, 4200, 2, "A3", -1, -1);
	_tmp22_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp22_, &_tmp23_);
	iter = _tmp23_;
	_tmp24_ = self->priv->paper_size_model;
	_tmp25_ = iter;
	gtk_list_store_set (_tmp24_, &_tmp25_, 0, 2159, 1, 2794, 2, "Letter", -1, -1);
	_tmp26_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp26_, &_tmp27_);
	iter = _tmp27_;
	_tmp28_ = self->priv->paper_size_model;
	_tmp29_ = iter;
	gtk_list_store_set (_tmp28_, &_tmp29_, 0, 2159, 1, 3556, 2, "Legal", -1, -1);
	_tmp30_ = self->priv->paper_size_model;
	gtk_list_store_append (_tmp30_, &_tmp31_);
	iter = _tmp31_;
	_tmp32_ = self->priv->paper_size_model;
	_tmp33_ = iter;
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, 1016, 1, 1524, 2, "4×6", -1, -1);
	_tmp34_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp34_);
	renderer = _tmp34_;
	_tmp35_ = self->priv->device_combo;
	_tmp36_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp35_, (GtkCellRenderer*) _tmp36_, TRUE);
	_tmp37_ = self->priv->device_combo;
	_tmp38_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp37_, (GtkCellRenderer*) _tmp38_, "text", 1);
	dpi = g_settings_get_int (_data7_->settings, "text-dpi");
	if (dpi <= 0) {
		dpi = DEFAULT_TEXT_DPI;
	}
	_tmp39_ = self->priv->text_dpi_combo;
	preferences_dialog_set_dpi_combo (self, _tmp39_, DEFAULT_TEXT_DPI, dpi);
	_tmp40_ = self->priv->text_dpi_combo;
	g_signal_connect_data (_tmp40_, "changed", (GCallback) ___lambda4__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	dpi = g_settings_get_int (_data7_->settings, "photo-dpi");
	if (dpi <= 0) {
		dpi = DEFAULT_PHOTO_DPI;
	}
	_tmp41_ = self->priv->photo_dpi_combo;
	preferences_dialog_set_dpi_combo (self, _tmp41_, DEFAULT_PHOTO_DPI, dpi);
	_tmp42_ = self->priv->photo_dpi_combo;
	g_signal_connect_data (_tmp42_, "changed", (GCallback) ___lambda5__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	preferences_dialog_set_page_side (self, (ScanType) g_settings_get_enum (_data7_->settings, "page-side"));
	_tmp43_ = self->priv->front_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp43_, "toggled", (GCallback) ___lambda6__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp44_ = self->priv->back_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp44_, "toggled", (GCallback) ___lambda7__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp45_ = self->priv->both_side_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp45_, "toggled", (GCallback) ___lambda8__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp46_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp46_);
	_g_object_unref0 (renderer);
	renderer = _tmp46_;
	_tmp47_ = self->priv->paper_size_combo;
	_tmp48_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp47_, (GtkCellRenderer*) _tmp48_, TRUE);
	_tmp49_ = self->priv->paper_size_combo;
	_tmp50_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp49_, (GtkCellRenderer*) _tmp50_, "text", 2);
	_tmp51_ = self->priv->brightness_adjustment;
	_tmp52_ = gtk_adjustment_get_lower (_tmp51_);
	_tmp53_ = _tmp52_;
	lower = _tmp53_;
	_tmp54_ = g_strdup_printf ("<small>%s</small>", _ ("Darker"));
	darker_label = _tmp54_;
	_tmp55_ = self->priv->brightness_adjustment;
	_tmp56_ = gtk_adjustment_get_upper (_tmp55_);
	_tmp57_ = _tmp56_;
	upper = _tmp57_;
	_tmp58_ = g_strdup_printf ("<small>%s</small>", _ ("Lighter"));
	lighter_label = _tmp58_;
	_tmp59_ = self->priv->brightness_scale;
	gtk_scale_add_mark (_tmp59_, lower, GTK_POS_BOTTOM, darker_label);
	_tmp60_ = self->priv->brightness_scale;
	gtk_scale_add_mark (_tmp60_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
	_tmp61_ = self->priv->brightness_scale;
	gtk_scale_add_mark (_tmp61_, upper, GTK_POS_BOTTOM, lighter_label);
	_tmp62_ = self->priv->brightness_adjustment;
	gtk_adjustment_set_value (_tmp62_, (gdouble) g_settings_get_int (_data7_->settings, "brightness"));
	_tmp63_ = self->priv->brightness_adjustment;
	g_signal_connect_data (_tmp63_, "value-changed", (GCallback) ___lambda9__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp64_ = self->priv->contrast_adjustment;
	_tmp65_ = gtk_adjustment_get_lower (_tmp64_);
	_tmp66_ = _tmp65_;
	lower = _tmp66_;
	_tmp67_ = g_strdup_printf ("<small>%s</small>", _ ("Less"));
	less_label = _tmp67_;
	_tmp68_ = self->priv->contrast_adjustment;
	_tmp69_ = gtk_adjustment_get_upper (_tmp68_);
	_tmp70_ = _tmp69_;
	upper = _tmp70_;
	_tmp71_ = g_strdup_printf ("<small>%s</small>", _ ("More"));
	more_label = _tmp71_;
	_tmp72_ = self->priv->contrast_scale;
	gtk_scale_add_mark (_tmp72_, lower, GTK_POS_BOTTOM, less_label);
	_tmp73_ = self->priv->contrast_scale;
	gtk_scale_add_mark (_tmp73_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
	_tmp74_ = self->priv->contrast_scale;
	gtk_scale_add_mark (_tmp74_, upper, GTK_POS_BOTTOM, more_label);
	_tmp75_ = self->priv->contrast_adjustment;
	gtk_adjustment_set_value (_tmp75_, (gdouble) g_settings_get_int (_data7_->settings, "contrast"));
	_tmp76_ = self->priv->contrast_adjustment;
	g_signal_connect_data (_tmp76_, "value-changed", (GCallback) ___lambda10__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	paper_width = g_settings_get_int (_data7_->settings, "paper-width");
	paper_height = g_settings_get_int (_data7_->settings, "paper-height");
	preferences_dialog_set_paper_size (self, paper_width, paper_height);
	_tmp77_ = self->priv->paper_size_combo;
	g_signal_connect_data (_tmp77_, "changed", (GCallback) ___lambda11__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	preferences_dialog_set_page_delay (self, g_settings_get_int (_data7_->settings, "page-delay"));
	_tmp78_ = self->priv->page_delay_3s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp78_, "toggled", (GCallback) ___lambda12__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp79_ = self->priv->page_delay_5s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp79_, "toggled", (GCallback) ___lambda13__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp80_ = self->priv->page_delay_7s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp80_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp81_ = self->priv->page_delay_10s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp81_, "toggled", (GCallback) ___lambda15__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp82_ = self->priv->page_delay_15s_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp82_, "toggled", (GCallback) ___lambda16__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_g_free0 (more_label);
	_g_free0 (less_label);
	_g_free0 (lighter_label);
	_g_free0 (darker_label);
	_g_object_unref0 (renderer);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return self;
}

PreferencesDialog*
preferences_dialog_new (GSettings* settings)
{
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, settings);
}

void
preferences_dialog_set_scan_devices (PreferencesDialog* self,
                                     GList* devices)
{
	gboolean have_selection = FALSE;
	gint index = 0;
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	self->priv->setting_devices = TRUE;
	have_selection = FALSE;
	if (self->priv->user_selected_device) {
		GtkComboBox* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = self->priv->device_combo;
		_tmp1_ = gtk_combo_box_get_active (_tmp0_);
		_tmp2_ = _tmp1_;
		have_selection = _tmp2_ >= 0;
	}
	index = 0;
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = devices;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			ScanDevice* _tmp3_;
			ScanDevice* device = NULL;
			_tmp3_ = _g_object_ref0 ((ScanDevice*) device_it->data);
			device = _tmp3_;
			{
				gint n_delete = 0;
				GtkListStore* _tmp4_;
				GtkTreeIter _tmp5_ = {0};
				gboolean _tmp6_;
				gint _tmp34_;
				n_delete = -1;
				_tmp4_ = self->priv->device_model;
				_tmp6_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp4_, &_tmp5_, NULL, index);
				iter = _tmp5_;
				if (_tmp6_) {
					gint i = 0;
					i = 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							gchar* name = NULL;
							gboolean matched = FALSE;
							GtkListStore* _tmp10_;
							GtkTreeIter _tmp11_;
							gchar* _tmp12_ = NULL;
							const gchar* _tmp13_;
							ScanDevice* _tmp14_;
							const gchar* _tmp15_;
							gint _tmp16_;
							if (!_tmp7_) {
								GtkListStore* _tmp8_;
								gboolean _tmp9_;
								_tmp8_ = self->priv->device_model;
								_tmp9_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp8_, &iter);
								if (!_tmp9_) {
									break;
								}
							}
							_tmp7_ = FALSE;
							_tmp10_ = self->priv->device_model;
							_tmp11_ = iter;
							gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 0, &_tmp12_, -1, -1);
							_g_free0 (name);
							name = _tmp12_;
							_tmp13_ = name;
							_tmp14_ = device;
							_tmp15_ = _tmp14_->name;
							matched = g_strcmp0 (_tmp13_, _tmp15_) == 0;
							if (matched) {
								n_delete = i;
								_g_free0 (name);
								break;
							}
							_tmp16_ = i;
							i = _tmp16_ + 1;
							_g_free0 (name);
						}
					}
				}
				if (n_delete >= 0) {
					gint i = 0;
					GtkListStore* _tmp17_;
					GtkTreeIter _tmp18_;
					ScanDevice* _tmp19_;
					const gchar* _tmp20_;
					_tmp17_ = self->priv->device_model;
					_tmp18_ = iter;
					_tmp19_ = device;
					_tmp20_ = _tmp19_->label;
					gtk_list_store_set (_tmp17_, &_tmp18_, 1, _tmp20_, -1, -1);
					{
						gboolean _tmp21_ = FALSE;
						i = 0;
						_tmp21_ = TRUE;
						while (TRUE) {
							GtkListStore* _tmp23_;
							GtkTreeIter _tmp24_ = {0};
							GtkListStore* _tmp25_;
							if (!_tmp21_) {
								gint _tmp22_;
								_tmp22_ = i;
								i = _tmp22_ + 1;
							}
							_tmp21_ = FALSE;
							if (!(i < n_delete)) {
								break;
							}
							_tmp23_ = self->priv->device_model;
							gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp23_, &_tmp24_, NULL, index);
							iter = _tmp24_;
							_tmp25_ = self->priv->device_model;
							gtk_list_store_remove (_tmp25_, &iter);
						}
					}
				} else {
					GtkListStore* _tmp26_;
					GtkTreeIter _tmp27_ = {0};
					GtkListStore* _tmp28_;
					GtkTreeIter _tmp29_;
					ScanDevice* _tmp30_;
					const gchar* _tmp31_;
					ScanDevice* _tmp32_;
					const gchar* _tmp33_;
					_tmp26_ = self->priv->device_model;
					gtk_list_store_insert (_tmp26_, &_tmp27_, index);
					iter = _tmp27_;
					_tmp28_ = self->priv->device_model;
					_tmp29_ = iter;
					_tmp30_ = device;
					_tmp31_ = _tmp30_->name;
					_tmp32_ = device;
					_tmp33_ = _tmp32_->label;
					gtk_list_store_set (_tmp28_, &_tmp29_, 0, _tmp31_, 1, _tmp33_, -1, -1);
				}
				_tmp34_ = index;
				index = _tmp34_ + 1;
				_g_object_unref0 (device);
			}
		}
	}
	while (TRUE) {
		GtkListStore* _tmp35_;
		GtkTreeIter _tmp36_ = {0};
		gboolean _tmp37_;
		GtkListStore* _tmp38_;
		_tmp35_ = self->priv->device_model;
		_tmp37_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp35_, &_tmp36_, NULL, index);
		iter = _tmp36_;
		if (!_tmp37_) {
			break;
		}
		_tmp38_ = self->priv->device_model;
		gtk_list_store_remove (_tmp38_, &iter);
	}
	if (!have_selection) {
		gchar* device = NULL;
		GSettings* _tmp39_;
		gchar* _tmp40_;
		gboolean _tmp41_ = FALSE;
		const gchar* _tmp42_;
		_tmp39_ = self->priv->settings;
		_tmp40_ = g_settings_get_string (_tmp39_, "selected-device");
		device = _tmp40_;
		_tmp42_ = device;
		if (_tmp42_ != NULL) {
			const gchar* _tmp43_;
			GtkTreeIter _tmp44_ = {0};
			gboolean _tmp45_;
			_tmp43_ = device;
			_tmp45_ = preferences_dialog_find_scan_device (self, _tmp43_, &_tmp44_);
			iter = _tmp44_;
			_tmp41_ = _tmp45_;
		} else {
			_tmp41_ = FALSE;
		}
		if (_tmp41_) {
			GtkComboBox* _tmp46_;
			GtkTreeIter _tmp47_;
			_tmp46_ = self->priv->device_combo;
			_tmp47_ = iter;
			gtk_combo_box_set_active_iter (_tmp46_, &_tmp47_);
		} else {
			GtkComboBox* _tmp48_;
			_tmp48_ = self->priv->device_combo;
			gtk_combo_box_set_active (_tmp48_, 0);
		}
		_g_free0 (device);
	}
	self->priv->setting_devices = FALSE;
}

gchar*
preferences_dialog_get_selected_device (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->device_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		gchar* device = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gchar* _tmp5_ = NULL;
		_tmp3_ = self->priv->device_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
		_g_free0 (device);
		device = _tmp5_;
		result = device;
		return result;
	}
	result = NULL;
	return result;
}

gchar*
preferences_dialog_get_selected_device_label (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->device_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		gchar* label = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gchar* _tmp5_ = NULL;
		_tmp3_ = self->priv->device_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
		_g_free0 (label);
		label = _tmp5_;
		result = label;
		return result;
	}
	result = NULL;
	return result;
}

void
preferences_dialog_set_selected_device (PreferencesDialog* self,
                                        const gchar* device)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkComboBox* _tmp2_;
	GtkTreeIter _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	self->priv->user_selected_device = TRUE;
	_tmp1_ = preferences_dialog_find_scan_device (self, device, &_tmp0_);
	iter = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->device_combo;
	_tmp3_ = iter;
	gtk_combo_box_set_active_iter (_tmp2_, &_tmp3_);
}

static gboolean
preferences_dialog_find_scan_device (PreferencesDialog* self,
                                     const gchar* device,
                                     GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	gboolean have_iter = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	have_iter = FALSE;
	_tmp0_ = self->priv->device_model;
	_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
	_vala_iter = _tmp1_;
	if (_tmp2_) {
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gchar* d = NULL;
				GtkListStore* _tmp7_;
				GtkTreeIter _tmp8_;
				gchar* _tmp9_ = NULL;
				const gchar* _tmp10_;
				if (!_tmp3_) {
					gboolean _tmp4_ = FALSE;
					if (!have_iter) {
						GtkListStore* _tmp5_;
						gboolean _tmp6_;
						_tmp5_ = self->priv->device_model;
						_tmp6_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp5_, &_vala_iter);
						_tmp4_ = _tmp6_;
					} else {
						_tmp4_ = FALSE;
					}
					if (!_tmp4_) {
						break;
					}
				}
				_tmp3_ = FALSE;
				_tmp7_ = self->priv->device_model;
				_tmp8_ = _vala_iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 0, &_tmp9_, -1, -1);
				_g_free0 (d);
				d = _tmp9_;
				_tmp10_ = d;
				if (g_strcmp0 (_tmp10_, device) == 0) {
					have_iter = TRUE;
				}
				_g_free0 (d);
			}
		}
	}
	result = have_iter;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static void
preferences_dialog_set_page_side (PreferencesDialog* self,
                                  ScanType page_side)
{
	g_return_if_fail (self != NULL);
	switch (page_side) {
		case SCAN_TYPE_ADF_FRONT:
		{
			GtkRadioButton* _tmp0_;
			_tmp0_ = self->priv->front_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
			break;
		}
		case SCAN_TYPE_ADF_BACK:
		{
			GtkRadioButton* _tmp1_;
			_tmp1_ = self->priv->back_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
			break;
		}
		default:
		case SCAN_TYPE_ADF_BOTH:
		{
			GtkRadioButton* _tmp2_;
			_tmp2_ = self->priv->both_side_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
			break;
		}
	}
}

ScanType
preferences_dialog_get_page_side (PreferencesDialog* self)
{
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ScanType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->front_side_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = SCAN_TYPE_ADF_FRONT;
		return result;
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->back_side_button;
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			result = SCAN_TYPE_ADF_BACK;
			return result;
		} else {
			result = SCAN_TYPE_ADF_BOTH;
			return result;
		}
	}
}

void
preferences_dialog_set_paper_size (PreferencesDialog* self,
                                   gint width,
                                   gint height)
{
	GtkTreeIter iter = {0};
	gboolean have_iter = FALSE;
	g_return_if_fail (self != NULL);
	{
		GtkListStore* _tmp0_;
		GtkTreeIter _tmp1_ = {0};
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->paper_size_model;
		_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
		iter = _tmp1_;
		have_iter = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gint w = 0;
			gint h = 0;
			GtkListStore* _tmp6_;
			GtkTreeIter _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			gboolean _tmp10_ = FALSE;
			if (!_tmp3_) {
				GtkListStore* _tmp4_;
				gboolean _tmp5_;
				_tmp4_ = self->priv->paper_size_model;
				_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &iter);
				have_iter = _tmp5_;
			}
			_tmp3_ = FALSE;
			if (!have_iter) {
				break;
			}
			_tmp6_ = self->priv->paper_size_model;
			_tmp7_ = iter;
			gtk_tree_model_get ((GtkTreeModel*) _tmp6_, &_tmp7_, 0, &_tmp8_, 1, &_tmp9_, -1, -1);
			w = _tmp8_;
			h = _tmp9_;
			if (w == width) {
				_tmp10_ = h == height;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				break;
			}
		}
	}
	if (!have_iter) {
		GtkListStore* _tmp11_;
		GtkTreeIter _tmp12_ = {0};
		gboolean _tmp13_;
		_tmp11_ = self->priv->paper_size_model;
		_tmp13_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp11_, &_tmp12_);
		iter = _tmp12_;
		have_iter = _tmp13_;
	}
	if (have_iter) {
		GtkComboBox* _tmp14_;
		GtkTreeIter _tmp15_;
		_tmp14_ = self->priv->paper_size_combo;
		_tmp15_ = iter;
		gtk_combo_box_set_active_iter (_tmp14_, &_tmp15_);
	}
}

gint
preferences_dialog_get_text_dpi (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	dpi = DEFAULT_TEXT_DPI;
	_tmp0_ = self->priv->text_dpi_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
		_tmp3_ = self->priv->text_dpi_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
		dpi = _tmp5_;
	}
	result = dpi;
	return result;
}

gint
preferences_dialog_get_photo_dpi (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	dpi = DEFAULT_PHOTO_DPI;
	_tmp0_ = self->priv->photo_dpi_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
		_tmp3_ = self->priv->photo_dpi_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
		dpi = _tmp5_;
	}
	result = dpi;
	return result;
}

gboolean
preferences_dialog_get_paper_size (PreferencesDialog* self,
                                   gint* width,
                                   gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_height = 0;
	_vala_width = _vala_height;
	_tmp0_ = self->priv->paper_size_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		_tmp3_ = self->priv->paper_size_model;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_vala_width, 1, &_vala_height, -1, -1);
		result = TRUE;
		if (width) {
			*width = _vala_width;
		}
		if (height) {
			*height = _vala_height;
		}
		return result;
	}
	result = FALSE;
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
	return result;
}

gint
preferences_dialog_get_brightness (PreferencesDialog* self)
{
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->brightness_adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}

void
preferences_dialog_set_brightness (PreferencesDialog* self,
                                   gint brightness)
{
	GtkAdjustment* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->brightness_adjustment;
	gtk_adjustment_set_value (_tmp0_, (gdouble) brightness);
}

gint
preferences_dialog_get_contrast (PreferencesDialog* self)
{
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->contrast_adjustment;
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}

void
preferences_dialog_set_contrast (PreferencesDialog* self,
                                 gint contrast)
{
	GtkAdjustment* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->contrast_adjustment;
	gtk_adjustment_set_value (_tmp0_, (gdouble) contrast);
}

gint
preferences_dialog_get_page_delay (PreferencesDialog* self)
{
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->page_delay_15s_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = 15000;
		return result;
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->page_delay_10s_button;
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			result = 10000;
			return result;
		} else {
			GtkRadioButton* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
			_tmp6_ = self->priv->page_delay_7s_button;
			_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
			_tmp8_ = _tmp7_;
			if (_tmp8_) {
				result = 7000;
				return result;
			} else {
				GtkRadioButton* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				_tmp9_ = self->priv->page_delay_5s_button;
				_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp11_) {
					result = 5000;
					return result;
				} else {
					result = 3000;
					return result;
				}
			}
		}
	}
}

void
preferences_dialog_set_page_delay (PreferencesDialog* self,
                                   gint page_delay)
{
	g_return_if_fail (self != NULL);
	if (page_delay >= 15000) {
		GtkRadioButton* _tmp0_;
		_tmp0_ = self->priv->page_delay_15s_button;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
	} else {
		if (page_delay >= 10000) {
			GtkRadioButton* _tmp1_;
			_tmp1_ = self->priv->page_delay_10s_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
		} else {
			if (page_delay >= 7000) {
				GtkRadioButton* _tmp2_;
				_tmp2_ = self->priv->page_delay_7s_button;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
			} else {
				if (page_delay >= 5000) {
					GtkRadioButton* _tmp3_;
					_tmp3_ = self->priv->page_delay_5s_button;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
				} else {
					GtkRadioButton* _tmp4_;
					_tmp4_ = self->priv->page_delay_3s_button;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, TRUE);
				}
			}
		}
	}
}

static void
preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                  GtkComboBox* combo,
                                  gint default_dpi,
                                  gint current_dpi)
{
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkCellRendererText* _tmp2_;
	GtkListStore* model = NULL;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	gint* scan_resolutions = NULL;
	gint* _tmp6_;
	gint scan_resolutions_length1;
	gint _scan_resolutions_size_;
	gint* _tmp7_;
	gint _tmp7__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combo != NULL);
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp0_);
	renderer = _tmp0_;
	_tmp1_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp1_, TRUE);
	_tmp2_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp2_, "text", 1);
	_tmp3_ = gtk_combo_box_get_model (combo);
	_tmp4_ = _tmp3_;
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp4_) : NULL);
	model = _tmp5_;
	_tmp6_ = g_new0 (gint, 6);
	_tmp6_[0] = 75;
	_tmp6_[1] = 150;
	_tmp6_[2] = 300;
	_tmp6_[3] = 600;
	_tmp6_[4] = 1200;
	_tmp6_[5] = 2400;
	scan_resolutions = _tmp6_;
	scan_resolutions_length1 = 6;
	_scan_resolutions_size_ = scan_resolutions_length1;
	_tmp7_ = scan_resolutions;
	_tmp7__length1 = scan_resolutions_length1;
	{
		gint* dpi_collection = NULL;
		gint dpi_collection_length1 = 0;
		gint _dpi_collection_size_ = 0;
		gint dpi_it = 0;
		dpi_collection = _tmp7_;
		dpi_collection_length1 = _tmp7__length1;
		for (dpi_it = 0; dpi_it < dpi_collection_length1; dpi_it = dpi_it + 1) {
			gint dpi = 0;
			dpi = dpi_collection[dpi_it];
			{
				gchar* label = NULL;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp12_;
				GtkTreeIter _tmp13_ = {0};
				GtkListStore* _tmp14_;
				GtkTreeIter _tmp15_;
				const gchar* _tmp16_;
				if (dpi == default_dpi) {
					gchar* _tmp8_;
					_tmp8_ = g_strdup_printf (_ ("%d dpi (default)"), dpi);
					_g_free0 (label);
					label = _tmp8_;
				} else {
					if (dpi == 75) {
						gchar* _tmp9_;
						_tmp9_ = g_strdup_printf (_ ("%d dpi (draft)"), dpi);
						_g_free0 (label);
						label = _tmp9_;
					} else {
						if (dpi == 1200) {
							gchar* _tmp10_;
							_tmp10_ = g_strdup_printf (_ ("%d dpi (high resolution)"), dpi);
							_g_free0 (label);
							label = _tmp10_;
						} else {
							gchar* _tmp11_;
							_tmp11_ = g_strdup_printf (_ ("%d dpi"), dpi);
							_g_free0 (label);
							label = _tmp11_;
						}
					}
				}
				_tmp12_ = model;
				gtk_list_store_append (_tmp12_, &_tmp13_);
				iter = _tmp13_;
				_tmp14_ = model;
				_tmp15_ = iter;
				_tmp16_ = label;
				gtk_list_store_set (_tmp14_, &_tmp15_, 0, dpi, 1, _tmp16_, -1, -1);
				if (dpi == current_dpi) {
					GtkTreeIter _tmp17_;
					_tmp17_ = iter;
					gtk_combo_box_set_active_iter (combo, &_tmp17_);
				}
				_g_free0 (label);
			}
		}
	}
	scan_resolutions = (g_free (scan_resolutions), NULL);
	_g_object_unref0 (model);
	_g_object_unref0 (renderer);
}

static void
preferences_dialog_device_combo_changed_cb (PreferencesDialog* self,
                                            GtkWidget* widget)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	if (self->priv->setting_devices) {
		return;
	}
	self->priv->user_selected_device = TRUE;
	_tmp0_ = preferences_dialog_get_selected_device (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_g_free0 (_tmp1_);
	if (_tmp2_) {
		GSettings* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = self->priv->settings;
		_tmp4_ = preferences_dialog_get_selected_device (self);
		_tmp5_ = _tmp4_;
		g_settings_set_string (_tmp3_, "selected-device", _tmp5_);
		_g_free0 (_tmp5_);
	}
}

static void
_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
	preferences_dialog_device_combo_changed_cb ((PreferencesDialog*) self, _sender);
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SimpleScan/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_scale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_scale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_3s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_3s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_5s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_5s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_7s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_7s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_10s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_10s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_15s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_15s_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "front_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, front_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, back_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "both_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, both_side_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_model));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_adjustment));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_adjustment));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "device_combo_changed_cb", G_CALLBACK(_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed));
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
	self->priv = preferences_dialog_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->device_combo);
	_g_object_unref0 (self->priv->text_dpi_combo);
	_g_object_unref0 (self->priv->photo_dpi_combo);
	_g_object_unref0 (self->priv->paper_size_combo);
	_g_object_unref0 (self->priv->brightness_scale);
	_g_object_unref0 (self->priv->contrast_scale);
	_g_object_unref0 (self->priv->device_model);
	_g_object_unref0 (self->priv->page_delay_3s_button);
	_g_object_unref0 (self->priv->page_delay_5s_button);
	_g_object_unref0 (self->priv->page_delay_7s_button);
	_g_object_unref0 (self->priv->page_delay_10s_button);
	_g_object_unref0 (self->priv->page_delay_15s_button);
	_g_object_unref0 (self->priv->text_dpi_model);
	_g_object_unref0 (self->priv->photo_dpi_model);
	_g_object_unref0 (self->priv->front_side_button);
	_g_object_unref0 (self->priv->back_side_button);
	_g_object_unref0 (self->priv->both_side_button);
	_g_object_unref0 (self->priv->paper_size_model);
	_g_object_unref0 (self->priv->brightness_adjustment);
	_g_object_unref0 (self->priv->contrast_adjustment);
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
		PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}

static inline gpointer
page_icon_get_instance_private (PageIcon* self)
{
	return G_STRUCT_MEMBER_P (self, PageIcon_private_offset);
}

PageIcon*
page_icon_construct (GType object_type,
                     const gchar* text,
                     gdouble r,
                     gdouble g,
                     gdouble b)
{
	PageIcon * self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (text != NULL, NULL);
	self = (PageIcon*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (text);
	_g_free0 (self->priv->text);
	self->priv->text = _tmp0_;
	self->priv->r = r;
	self->priv->g = g;
	self->priv->b = b;
	return self;
}

PageIcon*
page_icon_new (const gchar* text,
               gdouble r,
               gdouble g,
               gdouble b)
{
	return page_icon_construct (TYPE_PAGE_ICON, text, r, g, b);
}

static void
page_icon_real_get_preferred_width (GtkWidget* base,
                                    gint* minimum_width,
                                    gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	self = (PageIcon*) base;
	_vala_natural_width = PAGE_ICON_MINIMUM_WIDTH;
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}

static void
page_icon_real_get_preferred_height (GtkWidget* base,
                                     gint* minimum_height,
                                     gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	self = (PageIcon*) base;
	_vala_natural_height = (gint) round (PAGE_ICON_MINIMUM_WIDTH * G_SQRT2);
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}

static void
page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                               gint width,
                                               gint* minimum_height,
                                               gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	self = (PageIcon*) base;
	_vala_natural_height = (gint) (width * G_SQRT2);
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}

static void
page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                               gint height,
                                               gint* minimum_width,
                                               gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	self = (PageIcon*) base;
	_vala_natural_width = (gint) (height / G_SQRT2);
	_vala_minimum_width = _vala_natural_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}

static gboolean
page_icon_real_draw (GtkWidget* base,
                     cairo_t* c)
{
	PageIcon * self;
	gint w = 0;
	gint h = 0;
	cairo_text_extents_t extents = {0};
	const gchar* _tmp0_;
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
	const gchar* _tmp4_;
	gboolean result = FALSE;
	self = (PageIcon*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	w = gtk_widget_get_allocated_width ((GtkWidget*) self);
	h = gtk_widget_get_allocated_height ((GtkWidget*) self);
	if ((w * G_SQRT2) > ((gdouble) h)) {
		w = (gint) round (h / G_SQRT2);
	} else {
		h = (gint) round (w * G_SQRT2);
	}
	cairo_translate (c, (gdouble) ((gtk_widget_get_allocated_width ((GtkWidget*) self) - w) / 2), (gdouble) ((gtk_widget_get_allocated_height ((GtkWidget*) self) - h) / 2));
	cairo_rectangle (c, 0.5, 0.5, (gdouble) (w - 1), (gdouble) (h - 1));
	cairo_set_source_rgb (c, self->priv->r, self->priv->g, self->priv->b);
	cairo_fill_preserve (c);
	cairo_set_line_width (c, 1.0);
	cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
	cairo_stroke (c);
	_tmp0_ = self->priv->text;
	cairo_text_extents (c, _tmp0_, &_tmp1_);
	extents = _tmp1_;
	_tmp2_ = extents;
	_tmp3_ = extents;
	cairo_translate (c, ((w - _tmp2_.width) * 0.5) - 0.5, ((h + _tmp3_.height) * 0.5) - 0.5);
	_tmp4_ = self->priv->text;
	cairo_show_text (c, _tmp4_);
	result = TRUE;
	return result;
}

static void
page_icon_class_init (PageIconClass * klass,
                      gpointer klass_data)
{
	page_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PageIcon_private_offset);
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) page_icon_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) page_icon_real_get_preferred_height;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) page_icon_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) page_icon_real_get_preferred_width_for_height;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) page_icon_real_draw;
	G_OBJECT_CLASS (klass)->finalize = page_icon_finalize;
}

static void
page_icon_instance_init (PageIcon * self,
                         gpointer klass)
{
	self->priv = page_icon_get_instance_private (self);
}

static void
page_icon_finalize (GObject * obj)
{
	PageIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_ICON, PageIcon);
	_g_free0 (self->priv->text);
	G_OBJECT_CLASS (page_icon_parent_class)->finalize (obj);
}

GType
page_icon_get_type (void)
{
	static volatile gsize page_icon_type_id__volatile = 0;
	if (g_once_init_enter (&page_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageIcon), 0, (GInstanceInitFunc) page_icon_instance_init, NULL };
		GType page_icon_type_id;
		page_icon_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PageIcon", &g_define_type_info, 0);
		PageIcon_private_offset = g_type_add_instance_private (page_icon_type_id, sizeof (PageIconPrivate));
		g_once_init_leave (&page_icon_type_id__volatile, page_icon_type_id);
	}
	return page_icon_type_id__volatile;
}

